Skip to content

# AutoConnectAux API

## Constructor

### AutoConnectAux

    AutoConnectAux(const String& uri = String(""), const String& title = String(""), const bool menu = true, const AutoConnectElementVT addons = AutoConnectElementVT())

Parameters
  uriURI of this custom Web Page.
  titlePage title of this custom Web page. It will appear on the auto connection menu and at the top of that page.
  menuSpecifies whether to display this page on menu.
  addonsReference to AutoConnectElement collection.

## Public member functions

### add

    void add(AutoConnectElement& addon)

    void add(AutoConnectElementVT addons)

Add an element to the AutoConnectAux. An added element is displayed on the custom Web page invoked from the AutoConnect menu.

Parameters
  addonReference of AutoConnectElements. Specifies one of the AutoConnectElements classes.
  addonsAn array list of reference of AutoConnectElements. An list initialization of the std::vector can be used for the addons parameter cause the actual definition of type AutoConnectElementVT is `std::vector<std::reference_wrapper<AutoConnectElement>>`.

### getElement

    T& getElement<T>(const String& name)

    AutoConnectElement* getElement(const String& name)

Get a registered AutoConnectElement as specified name. If T is specified as an actual type of AutoConnectElements, it returns a reference to that instance.

Parameters
  TActual type name of AutoConnectElements as AutoConnectButton, AutoConnectCheckbox, AutoConnectElement, AutoConnectInput, AutoConnectRadio, AutoConnectSelect, AutoConnectSubmit, AutoConnectText.
  nameName of the AutoConnectElements to be retrieved.
Return value
  A reference of the AutoConnectElements. If a type is not specified returns a pointer.

### getElements

    AutoConnectElementVT& getElements(void)

Get vector of reference of all elements.

Return value
  A reference to std::vector of reference to AutoConnecctElements.

The getElements returns a reference to std::vector of reference to AutoConnecctElements. This function is provided to handle AutoConnectElemets owned by AutoConnectAux in bulk, and you can use each method of std::vector for a return value.

    // An example of getting type and name of all AutoConnectElements registered in AutoConnectAux.
    AutoConnectAux aux;
    // some code here...
    AutoConnectElementVt& elements = aux.getElements();
    for (AutoConnectElement& elm : elements) {
        Serial.printf("name<%s> as type %d\n", elm.name.c_str(), (int)elm.typeOf());
    }

### load

    bool load(const String& in)

    bool load(const __FlashStringHelper* in)

    bool load(Stream& in)

Load all AutoConnectElements elements from JSON document into AutoConnectAux as custom Web pages. The JSON document specified by the load function must be the document structure of AutoConnectAux. Its JSON document can describe multiple pages as an array.

Parameters
  inSpecifies the JSON document to be load. The load function can input the following objects.
  - String : Read-only String
  - PROGMEM : Character array contained in the flash
  - Stream : An entity that inherits stream class, generally SPIFFS or SD.
Return value
  trueJSON document as the custom Web pages successfully loaded.
  falseJSON document loading failed.

Load multiple custom Web pages separately

Multiple custom Web pages can be loaded at once with JSON as an array. But it will consume a lot of memory. By loading a JSON document by page as much as possible, you can reduce memory consumption.

### loadElement

    bool loadElement(const String& in, const String& name = String(""))

    bool loadElement(const __FlashStringHelper* in, const String& name = String(""))

    bool loadElement(Stream& in, const String& name = String(""))

Load specified element from JSON document into AutoConnectAux. The JSON document specified by the loadElement function must be the AutoConnectElement document structure. When loading from a JSON document that describes multiple elements, its description must be an array syntax.

Parameters
  inSpecifies the JSON document to be load. The load function can input the following objects.
  - String : Read-only String
  - PROGMEM : Character array contained in the flash
  - Stream : An entity that inherits stream class, generally SPIFFS or SD.
  nameSpecifies the name to be load. If the name is not specified, the loadElement function will load all elements contained in the JSON document.
Return value
  trueSpecified AutoConnectElements successfully loaded.
  falseJSON document loading failed.

Maybe it is an array

Please note that the JSON document that is the input for loadElement is an array syntax of AutoConnectElements when there are multiple elements. For example, the following JSON document has a syntax error:

    {
      "name": "Caption",
      "type": "ACText",
      "value": "Hello, world"
    },
    {
      "name": "Server",
      "type": "ACInput",
      "label": "Server address"
    }

The outermost `[`, `]` is missing.

### menu

    void menu(const bool post)

Set or reset the display as menu item for this AutoConnectAux. This function programmatically manipulates the menu parameter of the AutoConenctAux constructor.

Parameters
  trueShow on the menu.
  falseHidden on the menu.

### on

    void on(const AuxHandlerFunctionT handler, const AutoConnectExitOrder_t order = AC_EXIT_AHEAD)

Register the handler function of the AutoConnectAux.

Parameters
  handlerA function that behaves when a request to the AutoConnectAux page occurs. AuxHandlerFunctionT type is defined by the following declaration.

  `String handler(AutoConnectAux&, PageArgument&)`

  orderSpecifies when the handler is called with the following enumeration value.
  - AC_EXIT_AHEAD : Called before AutoConnect generates the HTML of the page. You set the value of AutoConnectElements in the handler then its value will be displayed on the page.
  - AC_EXIT_LATER : Called after AutoConnect generates the HTML of the page. You can append to HTML generated by AutoConnect.
  - AC_EXIT_BOTH : Called even before generating HTML and after generated.

### release

    bool release(const String& name)

Release a specified AutoConnectElement from AutoConenctAux. The release function is provided to dynamically change the structure of the custom Web pages with the sketch. By combining the release function and the add function or the loadElement function, the sketch can change the style of the custom Web page according to its behavior.

Parameters
  nameSpecifies the name of AutoConnectElements to be released.
Return value
  trueThe AutoConnectElement successfully released.
  falseThe AutoConnectElement can not be released.

### saveElement

    size_t saveElement(Stream& out, std::vector<String> const& names = {})

Write elements of AutoConnectAux to the stream. The saveElement function outputs the specified AutoConenctElements as a JSON document using the prettyPrintTo function of the ArduinoJson library.

Parameters
  outOutput stream to be output. SPIFFS, SD also Serial can be specified generally.
  namesThe array of the name of AutoConnectElements to be output. If the names parameter is not specified, all AutoConnectElements registered in AutoConnectAux are output.
Return value
  The number of bytes written.

The output format is pretty

The saveElement function outputs a prettified JSON document.

### setElementValue

    bool setElementValue(const String& name, const String value)

    bool setElementValue(const String& name, std::vector<String> const& values)

Sets the value of the specified AutoConnectElement. If values ​​is specified as a std::vector of String, the element that can set the values is the AutoConnectRadio or the AutoConnectSelect.

Parameters
  nameSpecifies the name of the AutoConnectElements that you want to set the value.
  valueSpecifies the value to be set.
  valuesSpecifies a reference of a std::vector of String. It contains the values of the AutoConnectRadio or the AutoConnectSelect.
Return value
  trueThe value has been set.
  falseAutoConnectElements with the specified name are not registered. Or the type of the value is not consistent with the specified AutoConnectElements.

You can directly access the value member variable.

If you are gripping with the sketch to the AutoConnectElements of the target that sets the value, you can access the value member variable directly. The following sketch code has the same effect.

    AutoConnectAux aux;
    // ... Griping the AutoConnectText here.
    aux.setElementValue("TEXT_FIELD", "New value");

    AutoConnectAux aux;
    // ... Griping the AutoConnectText here.
    AutoConnectText& text = aux.getElement<AutoConnectText>("TEXT_FIELD");
    text.value = "New value";

The difference between the setElementValue and the value access with the getElement is the certainty of the registration state for the element. The getElement returns an empty object if the element is not registered then a sketch assigns the value to it. May occur unexpected results and crashes. You should use the setElementValue if its registration is unsettled.

### setTitle

    void setTitle(const String& title)

Set the title string of the custom Web page. This title will be displayed as the menu title of the custom Web page.

Parameter
  titleTitle string to be display.

Not the menu title

The setTitle function is not set for the AutoConnect menu title. The effect of this function is that custom Web page only. To change the AutoConnect menu title use AutoConnectConfig::title.